



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS XMPP Framework 中文概述</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS XMPP Framework 中文概述</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 07:21:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>本篇文章翻译<a href="https://github.com/robbiehanson/XMPPFramework" rel="external nofollow noreferrer">XMPP Framework</a>中的<a href="https://github.com/robbiehanson/XMPPFramework/wiki/IntroToFramework" rel="external nofollow noreferrer">Overview of the XMPP Framework</a>部分</p>
<hr>
<h2>介绍</h2>
<p>The framework is divided into 2 parts: <br /><br />
1. xmpp核心部分 <br /><br />
2. xmpp扩展（roster，XEP's，可选的支持工具等）</p>
<p>xmpp核心部分实现了xmpp规范（<a href="http://xmpp.org/rfcs/rfc3920.html" rel="external nofollow noreferrer">RFC 3920</a>）</p>
<blockquote><p>请不要把聊天与xmpp混淆，xmpp全称是”可扩展消息与存在协议”，它是一种可以用于多种用途的通用协议，事实上目前有很多公司使用这个框架例如家庭自动化，在医院传达警报给护士。</p></blockquote>
<p>可扩展包括例如支持花名册，自动重连与多种xmpp扩展实现(<a href="http://xmpp.org/extensions/" rel="external nofollow noreferrer">XEP's</a>).。</p>
<h2>XMPP核心</h2>
<p>XMPP核心文件在本地命名为”Core”的文件夹中。这些文件包括：</p>
<ul><li>XMPPStream</li>
<li>XMPPParser</li>
<li>XMPPJID</li>
<li>XMPPElement</li>
<li>XMPPIQ</li>
<li>XMPPMessage</li>
<li>XMPPPresence</li>
<li>XMPPModule</li>
<li>XMPPLogging</li>
<li>XMPPInternal</li></ul>
<p>这个框架的核心是<code>XMPPStream</code>类，这是你将要交互使用的主要的类，它是所有的扩展与定义代码插入的类，它具有一些使框架灵活，可扩展，易于在上面开发有趣的功能。这些将在稍后的文档中更深入的讨论。</p>
<p>XMPPParser 是XMPPStream使用的内部类。你也许已经猜出它是做什么的了，你不需要以任何方式形式与这个解析器交互。</p>
<p>XMPPJID 提供了一个不变的JID (Jabber Identifier)实现，它支持解析JID's，并以各种形式提取JID的各个部分。它遵守NSCopying协议，一边JID's可以当做NSDictionary的key。它也遵守NSCoding协议。</p>
<p>XMPPElement 是3个主要XMPP元素的基类:XMPPIQ, XMPPMessage &amp; XMPPPresence. XMPPElement扩展NSXMLElement类，因此你有全部的NSXML的功能，检查任何xml元素。在这个章节有更多详细的描述<a href="#t2" rel="external nofollow noreferrer">Elements: IQ, Message, &amp; Presence</a>。</p>
<p>XMPPModule 提供可选植入扩展的基础类，如果你正在写你自己应用执行的代码。你很可能仅仅创建你自己的类，注册接受代理调用。但是如果你正在实现一个标准的XEP。或者你想你的应用指定扩展是可被植入，那么你要在XMPPModule上创建，Module在后面更详细的被介绍。</p>
<p>XMPPLogging 提供一个非常快，强大灵活的日志框架，它会在<a href="#xmpp-日志" rel="external nofollow noreferrer">XMPP Logging</a> 章节中讨论。</p>
<p>XMPPInternal 仅仅是关于核心和各种高级底层扩展内部的东西。</p>
<h2>元素: IQ, Message, &amp; Presence</h2>
<p>XMPPElement扩展NSXMLElement类，因此你有全部的NSXML的功能，检查任何xml元素。</p>
<ul><li>XMPPIQ -&gt; XMPPElement -&gt; NSXMLElement -&gt; NSXMLNode -&gt; NSObject</li>
<li>XMPPMessage -&gt; XMPPElement -&gt; NSXMLElement -&gt; NSXMLNode -&gt; NSObject</li>
<li>XMPPPresence -&gt; XMPPElement -&gt; NSXMLElement -&gt; NSXMLNode -&gt; NSObject</li></ul>
<p>除了NSXML基础功能外，还提供了<a href="http://code.google.com/p/xmppframework/source/browse/Categories/NSXMLElement+XMPP.h" rel="external nofollow noreferrer">NSXMLElement+XMPP</a> 类别。这个类别提供各种方便的方法让你的代码更简洁易读。例如：</p>
<pre class="prettyprint linenums"><code>[element attributeIntValueForName:@"age"];</code></pre>
<p>更多的信息请看<a href="https://github.com/robbiehanson/XMPPFramework/wiki/WorkingWithElements" rel="external nofollow noreferrer">Working With Elements</a>页面</p>
<h2>XMPPStream配置</h2>
<p>一个xmpp stream配置初始化被分为多个部分：</p>
<ul><li>配置如何连接到xmpp服务器</li>
<li>添加代理</li>
<li>添加 modules</li>
<li>连接</li>
<li>认证</li></ul>
<h3>配置连接</h3>
<p>对于大部分人来说，这仅涉及一个步骤 - 设置stream的myJID属性。例如：</p>
<pre class="prettyprint linenums"><code>xmppStream.myJID = [XMPPJID jidWithString:@"user@gmail.com"];</code></pre>
<p>该xmpp stream 将查找遵循XMPP RFC的剩余信息，这包括正在进行的SRV查找_xmpp-client._tcp.domain。在上面的例子中，使用Gmail，谷歌服务器可能会返回类似"talk.google.com"，然后xmpp stream将会链接到该服务器，如果SRV查找查找失败，那么xmpp stream 将会简单链接到JID's domain。</p>
<p>如果你知道你正在连接到不具有xmpp SRV记录的xmpp服务器，你可以告诉xmpp stream 通过指定的主机名跳过SRV查找，例如：</p>
<pre class="prettyprint linenums"><code>xmppStream.myJID = [XMPPJID jidWithString:@"user@myCompany.com"];<br />
xmppStream.hostName = @"myCompany.com";</code></pre>
<p>主机名也会派上用场，当你使用一个开发xmpp服务器，可能服务器是在背地网络可用的，或者不具有DNS地址等，例如：</p>
<pre class="prettyprint linenums"><code>xmppStream.myJID = [XMPPJID jidWithString:@"user@dev1.myCompany.com"];<br />
xmppStream.hostName = @"192.168.2.27";</code></pre>
<p>另一个可选的属性是主机端口，默认情况下，并按照xmpp规范。几乎所有的服务器上的端口都在5222运行，如果你的服务器在不同的端口上运行，那可以设置主机端口的属性。</p>
<h3>添加代理</h3>
<p>XMPPStream有一些旨在使框架灵活，可扩展，易于在上面开发有趣的功能。其中之一使用MulticastDelegate。</p>
<p>什么是MulticastDelegate？</p>
<p>xmpp framework需要支持扩展的数量不受限制，这包括对这个框架的官方扩展，以及任何数量的扩展或你想要插入这个框架的自定义代码。因此传统的代理模式是行不通的，xmpp 模块和扩展需要分开到自己单独的类，但每个类都需要接受代理方法。而标准NSNotification架构将无法胜任，一些代理要求返回变量。（加上它真的很烦人要从userInfo字典的通知中提取参数）。</p>
<p>因此一个MulticastDelegate允许你使用一个标准的代理模式插入框架中，但它允许多个类接受想用的代理通知。这样做的好处是，你不必把所有的xmpp处理代码在一个类中。你可以认为你合适的方法分开处理在不同的类中。</p>
<p>你可以任何时间添加/删除XMPPStream的代理对象：</p>
<pre class="prettyprint linenums"><code>[xmppStream addDelegate:self delegateQueue:dispatch_get_main_queue()];<br />
...<br />
[xmppStream removeDelegate:self];</code></pre>
<p>更多关于MulticastDelegate的讨论可以在<a href="https://github.com/robbiehanson/XMPPFramework/wiki/MulticastDelegate" rel="external nofollow noreferrer">这里</a>找到。线程和队列更详细的讨论可以在<a href="https://github.com/robbiehanson/XMPPFramework/wiki/Threading" rel="external nofollow noreferrer">这里</a>找到。</p>
<h3>添加 Modules</h3>
<p>这有一些关于这个框架的扩展，当然，你可以如你所愿写尽可能多的扩展。我们不会检查所有可用的扩展，但我们会列出几个在这里示例。</p>
<ul><li>XMPPReconnect - 自动重新连接，如果你意外断开。</li>
<li>XMPPRoster - 提供标准的xmpp花名册支持</li>
<li>XMPPRoom - 提供多人聊天支持.</li>
<li>XMPPPubSub - 发布订阅</li></ul>
<p>作为例子，我们将会插入XMPPReconnect模块在我们的stream：</p>
<pre class="prettyprint linenums"><code>xmppReconnect = [ [XMPPReconnect alloc] init];

// Optional configuration of xmppReconnect could go here.<br />
// The defaults are fine for our purposes.

[xmppReconnect activate:xmppStream];

// You can also optionally add delegates to the module.

[xmppReconnect addDelegate:self delegateQueue:dispatch_get_main_queue()];

// And that's all that is needed.<br />
// The module will receive any delegate methods it needs automatically<br />
// from the xmpp stream, and will continue to do its thing unless you deactivate it.</code></pre>
<h3>连接</h3>
<p>当你准备好，你可以开始连接进程：</p>
<pre class="prettyprint linenums"><code>NSError *error = nil;<br />
if (![xmppStream connect:&amp;error])<br />
{<br />
    NSLog(@"Oops, I probably forgot something: %@", error);<br />
}</code></pre>
<p>如果你忘记设置必需的属性，例如myJID，那么connect方法会返回NO，错误消息会通知你的问题。</p>
<p>在连接过程中，客户端和服务器经过一个xmpp握手。在此期间，服务器通知各种它支持以及需要的各种协议给客户端。有些服务器可能需要连接通过SSL/TLS。如果是这样的情况下，xmpp stream将自动保护连接，如果你正在连接服务器以不正确X509证书，你可能需要实现xmppStream:willSecureWithSettings: 代理方法来改变默认的安全设置。</p>
<h3>认证</h3>
<p>所有的连接握手结束后xmppStreamDidConnect: 代理方法被调用。这通常是大多数客户端应启动验证过程：</p>
<pre class="prettyprint linenums"><code>- (void)xmppStreamDidConnect:(XMPPStream *)sender<br />
{<br />
    [xmppStream authenticateWithPassword:password error:NULL];<br />
}</code></pre>
<h2>XMPP 日志</h2>
<p>这有几个目标对于整个XMPP架构日志：</p>
<ul><li><p><strong>它必须支持多种日志级别.</strong> <br> <br /><br />
不是所有的日志消息具有相同的优先级。有些是有关错误的，而其他都只是信息。日志分级帮助开发者保证他们的日志信息完整的，能够打开和关闭他们没有任何困难。</p></li>
<li><p><strong>它必须在每个文件基础上可配置</strong> <br> <br /><br />
一个全局日志级别不会接受当这个框架包含了这么多文件。加上调试的问题往往开发者只希望看到几个文件的日志语句。</p></li>
<li><p><strong>它必须可配置于终端用户</strong> <br> <br /><br />
xmpp framework 需要对日志语句完全控制，用户有很多不同的需求。一些想要日志声明到一个文件中，一些可能想要日志声明到数据库里。或者可能他们需要针对日志声明在不同的地方，取决于日志声明来源于app中还是xmpp framework。</p></li></ul>
<p>我从事客户端多年来的工作，我看到第三方框架一遍又一遍发生同样的问题。第三方库自带散落着的NSLog语句，最终需要用户通过库注释掉NSLog语句，或者将它们转换为一些原始的自定义宏的版本。</p>
<p>xmpp framework 采用了专业的日志框架<a href="https://github.com/robbiehanson/CocoaLumberjack" rel="external nofollow noreferrer">CocoaLumberjack</a>。这个日志框架实际上比的NSLog更快，做同样的事情时也是如此。此外，它还支持大量不同的配置，并允许终端用户甚至可以添加自己的自定义日志记录，筛选和格式化。</p>
<p>下面是你需要知道的XMPPFramework有关日志的设置：</p>
<p>对于在框架内部大多数文件顶部你会发现如下：</p>
<pre class="prettyprint linenums"><code>// Log levels: off, error, warn, info, verbose<br />
static const int xmppLogLevel = XMPP_LOG_LEVEL_WARN;</code></pre>
<p>如你所见有4个日志级别(加上 XMPP_LOG_LEVEL_NONE):</p>
<ul><li>Error</li>
<li>Warning</li>
<li>Info</li>
<li>Verbose</li></ul>
<p>您可以更改任何文件的日志级别，要它输出更多的信息。</p>
<p>除了这一点，可启用一个跟踪标记。当启用跟踪，它输出正在调用的方法。</p>
<p>请注意，跟踪是从日志等级分开的。例如，一个可以设置日志级别设置为警告，并启用跟踪像这样：</p>
<pre class="prettyprint linenums"><code>// Log levels: off, error, warn, info, verbose<br />
static const int xmppLogLevel = XMPP_LOG_LEVEL_WARN | XMPP_LOG_FLAG_TRACE;</code></pre>
<p>就代码而言意味着：</p>
<pre class="prettyprint linenums"><code>XMPPLogTrace(); // Enabled - Will spit out "&lt;FileName&gt;: &lt;MethodName&gt;"<br />
XMPPLogError(@"I will get logged");<br />
XMPPLogWarn(@"I will get logged");<br />
XMPPLogInfo(@"I will NOT get logged");<br />
XMPPLogVerbose(@"I will NOT get logged");</code></pre>
<p>除此之外，XMPPStream有一个选项使你能够看到正在发送的原始XML sent/received。你可以把它放在XMPPStream.m像这样：</p>
<pre class="prettyprint linenums"><code>// Log levels: off, error, warn, info, verbose<br />
static const int xmppLogLevel = XMPP_LOG_LEVEL_INFO | XMPP_LOG_FLAG_SEND_RECV;</code></pre>
<p>当你启动应用程序，您需要配置lumberjack框架。对于初学者来说，你可以这样简单的设置在你的AppDelegate：</p>
<pre class="prettyprint linenums"><code>#import "DDLog.h"<br />
#import "DDTTYLogger.h"

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification<br />
{<br />
    [DDLog addLogger:[DDTTYLogger sharedInstance] withLogLevel:XMPP_LOG_FLAG_SEND_RECV];

    // All your other code...<br />
}</code></pre>
<p>更多关于Lumberjack信息参考<a href="https://github.com/robbiehanson/CocoaLumberjack" rel="external nofollow noreferrer">这里</a>。 <br /><br />
For more information about Lumberjack take a look at its <a href="https://github.com/robbiehanson/CocoaLumberjack" rel="external nofollow noreferrer">project page</a>.</p>
<h2>更多信息</h2>
<p>想要立刻开始？</p>
<ul><li><a href="https://github.com/robbiehanson/XMPPFramework/wiki/GettingStarted_iOS" rel="external nofollow noreferrer">Get started using XMPPFramework on iOS</a></li>
<li><a href="https://github.com/robbiehanson/XMPPFramework/wiki/GettingStarted_Mac" rel="external nofollow noreferrer">Get started using XMPPFramework on Mac OS X</a></li></ul>
<p>扩展你的知识！</p>
<ul><li><p><a href="https://github.com/robbiehanson/XMPPFramework/wiki/WorkingWithElements" rel="external nofollow noreferrer">Learn about working with xml/xmpp elements</a></p></li>
<li><p><a href="https://github.com/robbiehanson/XMPPFramework/wiki/Threading" rel="external nofollow noreferrer">Learn about XMPPFramework's threading architecture</a></p></li></ul>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxdlmd9.html">Linux模块机制浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwod5z9.html">手机端多种分享plugin插件地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy2owm9.html">tp5 中 model 的删除方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7vmyjq.html">iOS - property，strong，weak，retain，assign，copy，nomatic 的区别及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn6o629.html">float浮动问题：会造成父级元素高度坍塌；</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x37mz8.html">6）Java中String类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mnme1q.html">创建透明的UIToolbar</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mjyoeq.html">Mysql表操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjoe2k9.html">POJ 3414 Pots &lpar; BFS &comma; 打印路径 ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1dy339.html">SET XACT&lowbar;ABORT 的用法&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo16pxq.html">Effective C&plus;&plus;：规定12：不要忘了复制的对象时，它的每一个组成部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p3jon8.html">Hybrid App（一）App开发选型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zmd7j9.html">简单介绍java Enumeration</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey3x0x9.html">java第二次实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkrl6e8.html">初识vue&mdash;&mdash;起步</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17xdgq.html">Android 项目中用得最多最火的第三方框架可能都在这里了</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jz1ev8.html">web服务器，验证码，Xftp使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0ee59.html">go  &lbrack;第一篇&rsqb;初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvjnlj8.html">单片机课程设计&mdash;&mdash;课程设计之四位加法计算器（2）（C代码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7oo69.html">linux 清空文件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyd2v5xq.html">持久化消息队列memcacheq的安装配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde55w79.html">在线运行HTML代码器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvdd0zq.html">eclipse git 整合</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m77gjq.html">tomcat与IIS在多IP服务器下的支持</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e100zm9.html">DirectShow学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdo5zz8.html">F&period;I&period;S本地环境的搭建教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/96om7xy9.html">Codeforces 475D CGCDSSQ&lpar;分治&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0enkgq.html">CF444C DZY Loves Colors</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1dyd38.html">ＳＱＬ技术内幕－4  row&lowbar;number&lpar;&rpar; over&lpar; partition  by XX  order  by XX&rpar;的用法（区别于group by 和order  by）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvdrmoq.html">14个Xcode中常用的快捷键操作</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
